Echo1.0发布

Echo是一个分布式的代理共享和管理系统，以长链接的方式连接多个运行在任意位置的终端，并将终端的网络资源整理为一套代理ip集群系统。echo提供整体的鉴权、流量监控、quota控制的功能。

1. Echo天然支持复杂网络环境，所以可以将代理终端部署在手机(甚至树莓派等终端设备)
2. Echo支持代理ip统一的集群管理，所以可以作为ADSL拨号的服务资源的的统一管理出口。使用ADSl使用统一的，稳定的ip出口提供代理服务(而不需要沉重的redis负担)
3. Echo支持sdk，目前提供完善的android APK和gradle依赖(这个作用你懂的😁)
4. Echo分布式设计，天然集群版，无资源瓶颈上限。各节点自动双通道HA热备，无单点风险。
5. Echo全程NIO设计，对资源消耗少，支持并发高(所以代码难度大，可以买个好价钱)，理论上代理最大吞吐占满节点带宽。
6. Echo系统扩展能力强，原则是echo的底层设计使得echo支持任意网络协议转发（udp、tcp、vpn等），且任意协议支持不需要终端升级
7. 终端命令控制，你可以通过http接口将特定指令下发到对应终端.实现如shell执行、ip重播等需求。

# Echo原理架构
为了证明Echo的分布式架构原理，这里特意放出Echo的结构图。展示echo的内部设计概念。

## Echo整体时序图
![时许图](img/img_echo/g4_sequence.png)

## Echo整体架构图
看完了时序图再来理解架构图
![Echo整体架构图](img/img_echo/g4_architecture.png)

# Echo使用流程
使用流程基本不会发生变化，但是app、web后台的页面布局未来可能发生变化。

首先echo的官网是: http://echonew.virjar.com/ 如果网络比较慢，你可以玩一玩左边的小蜘蛛，挺可爱的小蜘蛛。之后的注册登录不用太多讲述。
![主页](img/img_echo/echo_web_login.png)

登录之后你能看到一个dashboard
![dashboard](img/img_echo/g4_dashboard.png)

之后你需要做两件事情
1. 充点钱(不是必须，但是可以发个红包emmm)
2. 点击app下载，并且安装到你的手机中。之后进行登录。然后等待3-5分钟
![手机登录样例](img/img_echo/g4_adr_main.jpg)

# 使用代理ip服务
在web页面代理tab应该可以看到一个代理ip资源。或者使用代理ip提取接口可以提取到代理ip配置。

之后使用curl命令进行网络测试
```
virjar-share:~ virjar$ curl -x "virjar:virjar@echonew.virjar.com:33247" https://www.baidu.com
<!DOCTYPE html>
<!--STATUS OK--><html> <head><meta http-equiv=content-type content=text/html;charset=utf-8><meta http-equiv=X-UA-Compatible content=IE=Edge><meta content=always name=referrer><link rel=stylesheet type=text/css href=https://ss1.bdstatic.com/5eN1bjq8AAUYm2zgoY3K/r/www/cache/bdorz/baidu.min.css><title>百度一下，你就知道</title></head> <body link=#0000cc> <div id=wrapper> <div id=head> <div class=head_wrapper> <div class=s_form> <div class=s_form_wrapper> <div id=lg> <img hidefocus=true src=//www.baidu.com/img/bd_logo1.png width=270 height=129> </div> <form id=form name=f action=//www.baidu.com/s class=fm> <input type=hidden name=bdorz_come value=1> <input type=hidden name=ie value=utf-8> <input type=hidden name=f value=8> <input type=hidden name=rsv_bp value=1> <input type=hidden name=rsv_idx value=1> <input type=hidden name=tn value=baidu><span class="bg s_ipt_wr"><input id=kw name=wd class=s_ipt value maxlength=255 autocomplete=off autofocus=autofocus></span><span class="bg s_btn_wr"><input type=submit id=su value=百度一下 class="bg s_btn" autofocus></span> </form> </div> </div> <div id=u1> <a href=http://news.baidu.com name=tj_trnews class=mnav>新闻</a> <a href=https://www.hao123.com name=tj_trhao123 class=mnav>hao123</a> <a href=http://map.baidu.com name=tj_trmap class=mnav>地图</a> <a href=http://v.baidu.com name=tj_trvideo class=mnav>视频</a> <a href=http://tieba.baidu.com name=tj_trtieba class=mnav>贴吧</a> <noscript> <a href=http://www.baidu.com/bdorz/login.gif?login&amp;tpl=mn&amp;u=http%3A%2F%2Fwww.baidu.com%2f%3fbdorz_come%3d1 name=tj_login class=lb>登录</a> </noscript> <script>document.write('<a href="http://www.baidu.com/bdorz/login.gif?login&tpl=mn&u='+ encodeURIComponent(window.location.href+ (window.location.search === "" ? "?" : "&")+ "bdorz_come=1")+ '" name="tj_login" class="lb">登录</a>');
                </script> <a href=//www.baidu.com/more/ name=tj_briicon class=bri style="display: block;">更多产品</a> </div> </div> </div> <div id=ftCon> <div id=ftConw> <p id=lh> <a href=http://home.baidu.com>关于百度</a> <a href=http://ir.baidu.com>About Baidu</a> </p> <p id=cp>&copy;2017&nbsp;Baidu&nbsp;<a href=http://www.baidu.com/duty/>使用百度前必读</a>&nbsp; <a href=http://jianyi.baidu.com/ class=cp-feedback>意见反馈</a>&nbsp;京ICP证030173号&nbsp; <img src=//www.baidu.com/img/gs.gif> </p> </div> </div> </div> </body> </html>
virjar-share:~ virjar$ curl -x "virjar:密码被打码了@echonew.virjar.com:33247" http://myip.ipip.net/
当前 IP：121.37.172.3  来自于：中国 上海 上海  电信/联通
virjar-share:~ virjar$
```

再之后的，大家使用代理ip放到python或者java、或者配置到浏览器里面的使用方法，和其他代理ip供应商都一样了。

# 后记

good luck and charge money !!